#include "dbase.h"

/* delete a row from database */
int delrow( int argc, char* argv[] )
{
    char dbname[256], bakname[128];
    FILE* file;
    t_row* row;
    unsigned long id1, id2;

    if ( argc < 4 ) {
        printf("usage: %s delete [database] [row id]\n", argv[0]);
        return -1;
    }

    if ( 2 != sscanf( argv[3], "%08lx%08lx", &id1, &id2 )) {
        printf("Row ID must be the 16 character row id string. '%s' is invalid.\n", argv[3]);
        return -1;
    }

    /* read database */
    if (readdb( argv[2] )) {
        perror( argv[2] );
        return -1;
    }

    /* remove row */
    for ( row = (t_row*) GetFirst( &rowList ); row;
          row = (t_row*) GetNext( &row->node ) ) {
        if ( (row->id1 == id1) && (row->id2 == id2) ) {
            RemNode( &row->node );
            break;
        }
    }
    if (!row) {
        printf("Row ID '%s' not found.\n", argv[3] );
        return -1;
    }

    /* backup old file */
    sprintf( dbname, "%s" DB_FILE_EXTENSION, argv[2] );
    sprintf( bakname, "%s" DB_FILE_EXTENSION DB_BAK_EXTENSION, argv[2] );
    remove( bakname );
    rename( dbname, bakname );

    /* create new file */
    file = fopen( dbname, "w" );
    if (!file) {
        perror( dbname );
        return -1;
    }

    /* write all rows */
    for ( row = (t_row*) GetFirst( &rowList ); row;
          row = (t_row*) GetNext( &row->node ) )
        if (writerow( file, dbname, row ))
            return -1;

    return 0;
}
