#include "dbase.h"

/* output data according to format string */
int printdb( int argc, char* argv[] )
{
    char* format;
    int i,flen,strip=0;
    t_row* row;
    unsigned int rowid1=0, rowid2;
    t_textType textMode=text;

    if ( argc < 4 ) {
        printf("usage: %s print [database] {-u | -h} {-i rowid} [format]\n", argv[0]);
        return -1;
    }

    if ( readdb( argv[2] ) ) {
        perror( argv[2] );
        return -1;
    }

    /* options? */
    for ( i=3; i<argc; i++ ) {
        if ( '-' == argv[i][0] ) {

            switch ( argv[i][1] ) {

            case 'i': /* list a specific rowid */
                if ( argc < 5 ) {
                    printf("Too few arguments!\n");
                    return -1;
                }

                if ( 2 != sscanf( argv[4], "%08x%08x", &rowid1, &rowid2 ) ) {
                    printf("Invalid rowid '%s'.\n", argv[4] );
                    return -1;
                }
                
                i++; /* skip rowid parameter */
                break;
                
            case 's': /* strip all control chars */
                strip=1;
                break;
                
            case 'u':
                textMode=url;
                break;

            case 'h':
                textMode=html;
                break;

            default:
                printf("Unknown option '%s'.\n", argv[i] );
                break;
            }
        }
        else
            break;
    }
    
    format = argv[i];
    flen = strlen( format );

    for ( row = (t_row*) GetFirst( &rowList ); row;
          row = (t_row*) GetNext( &row->node ) ) {

	  /* if a specific row is specified, look for it */
	  if ( rowid1 ) {
              if ( !(( rowid1 == row->id1 ) && ( rowid2 == row->id2 )) )
		  continue;
	  }

          print_row( row, format, textMode );
    }

    return 0;
}

